package gregapi.gui;

import static gregapi.data.CS.T;
import static gregapi.data.CS.ZL_STRING;
import gregapi.code.ArrayListNoNulls;
import gregapi.data.LH;
import gregapi.tileentity.ITileEntityInventoryGUI;
import gregapi.util.ST;
import gregapi.util.UT;

import java.util.List;

import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.inventory.IInventory;
import net.minecraft.inventory.Slot;
import net.minecraft.item.ItemStack;

/**
 * @author Gregorius Techneticies
 */
public class Slot_Normal extends Slot {
	private String[] mToolTips = ZL_STRING;
	private String[] mToolTipColors = ZL_STRING;
	
    public final int mIndex;
    public final ITileEntityInventoryGUI mInventory;
    
	public Slot_Normal(ITileEntityInventoryGUI aInventory, int aIndex, int aX, int aY) {
		super(aInventory instanceof IInventory ? (IInventory)aInventory : null, aIndex, aX, aY);
		mInventory = aInventory;
		mIndex = aIndex;
	}
	
    public List<String> getTooltip(EntityPlayer aPlayer, boolean aF3_H) {
    	ArrayListNoNulls<String> rList = new ArrayListNoNulls<String>();
    	for (int i = 0; i < mToolTips.length; i++) {
    		if (mToolTipColors[i] == null) mToolTipColors[i] = LH.Chat.GRAY;
    		rList.add(mToolTipColors[i] + LH.get(mToolTips[i]));
    	}
    	return rList;
    }
    
    public Slot_Normal setTooltip(String aTooltip, String aToolTipColor) {
    	mToolTips = new String[] {aTooltip};
    	mToolTipColors = new String[] {aToolTipColor};
    	return this;
    }
    
    public Slot_Normal setTooltips(String[] aTooltips, String[] aToolTipColors) {
    	mToolTips = aTooltips;
    	mToolTipColors = (aToolTipColors.length < mToolTips.length ? mToolTipColors = new String[mToolTips.length] : aToolTipColors);
    	return this;
    }
    
    @Override public boolean func_111238_b() {return T;}
    @Override public void onSlotChange(ItemStack aStack, ItemStack aStack2) {if (ST.equal(aStack, aStack2, T)) {int tDifference = aStack2.stackSize - aStack.stackSize; if (tDifference > 0) onCrafting(aStack, tDifference);}}
    @Override protected void onCrafting(ItemStack aStack, int aDifference) {/**/}
    @Override protected void onCrafting(ItemStack aStack) {/**/}
    @Override public void onPickupFromSlot(EntityPlayer aPlayer, ItemStack aStack) {onSlotChanged();}
    @Override public boolean isItemValid(ItemStack aStack) {return T;}
    @Override public ItemStack getStack() {return mInventory.getStackInSlotGUI(mIndex);}
    @Override public boolean getHasStack() {return getStack() != null;}
    @Override public void putStack(ItemStack aStack) {mInventory.setInventorySlotContentsGUI(mIndex, aStack); onSlotChanged();}
    @Override public void onSlotChanged() {mInventory.markDirtyGUI();}
    @Override public int getSlotStackLimit() {return mInventory.getInventoryStackLimitGUI(mIndex);}
    @Override public ItemStack decrStackSize(int aAmount) {return mInventory.decrStackSizeGUI(mIndex, aAmount);}
    @Override public boolean isSlotInInventory(IInventory aInventory, int aIndex) {return aInventory == mInventory && aIndex == mIndex;}
    @Override public boolean canTakeStack(EntityPlayer aPlayer) {return UT.Entities.isCreative(aPlayer) || !ST.debug(getStack());}
    @Override public int getSlotIndex() {return mIndex;}
}