package gregapi.item;

import static gregapi.data.CS.ERR;
import static gregapi.data.CS.OUT;
import static gregapi.data.CS.T;
import static gregapi.data.CS.W;
import gregapi.GT_API;
import gregapi.api.Abstract_Mod;
import gregapi.data.MD;
import gregapi.data.MT;
import gregapi.data.OP;
import gregapi.lang.LanguageHandler;
import gregapi.util.ST;
import gregapi.util.UT;

import java.util.List;

import net.minecraft.client.renderer.texture.IIconRegister;
import net.minecraft.creativetab.CreativeTabs;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.util.IIcon;
import cpw.mods.fml.relauncher.Side;
import cpw.mods.fml.relauncher.SideOnly;

/**
 * @author Gregorius Techneticies
 */
public class ItemIntegratedCircuit extends ItemBase {
	public ItemIntegratedCircuit(String aUnlocalized, String aEnglish) {
		super(MD.GAPI.mID, aUnlocalized, aEnglish, "");
		setHasSubtypes(T);
		setMaxDamage(0);
		
		UT.Crafting.shaped(ST.make(this, 1, 0), UT.Crafting.Bits.DEFAULT_NAC_REV_NCC	, new Object[] {"GhG", "SSS", "GwG", 'G', OP.gearGtSmall.dat(MT.TECH.AnyIron		), 'S', OP.stick.dat(MT.TECH.AnyIron		)});
		UT.Crafting.shaped(ST.make(this, 1, 0), UT.Crafting.Bits.DEFAULT_NAC_NCC		, new Object[] {"GhG", "SSS", "GwG", 'G', OP.gearGtSmall.dat(MT.TECH.AnyIronSteel	), 'S', OP.stick.dat(MT.TECH.AnyIronSteel	)});
		
		UT.Crafting.shaped(ST.make(this, 1, 1), UT.Crafting.Bits.DEFAULT, new Object[] {"d  ", " P ", "   ", 'P', ST.make(this, 1, W)});
		UT.Crafting.shaped(ST.make(this, 1, 2), UT.Crafting.Bits.DEFAULT, new Object[] {" d ", " P ", "   ", 'P', ST.make(this, 1, W)});
		UT.Crafting.shaped(ST.make(this, 1, 3), UT.Crafting.Bits.DEFAULT, new Object[] {"  d", " P ", "   ", 'P', ST.make(this, 1, W)});
		UT.Crafting.shaped(ST.make(this, 1, 4), UT.Crafting.Bits.DEFAULT, new Object[] {"   ", " Pd", "   ", 'P', ST.make(this, 1, W)});
		UT.Crafting.shaped(ST.make(this, 1, 5), UT.Crafting.Bits.DEFAULT, new Object[] {"   ", " P ", "  d", 'P', ST.make(this, 1, W)});
		UT.Crafting.shaped(ST.make(this, 1, 6), UT.Crafting.Bits.DEFAULT, new Object[] {"   ", " P ", " d ", 'P', ST.make(this, 1, W)});
		UT.Crafting.shaped(ST.make(this, 1, 7), UT.Crafting.Bits.DEFAULT, new Object[] {"   ", " P ", "d  ", 'P', ST.make(this, 1, W)});
		UT.Crafting.shaped(ST.make(this, 1, 8), UT.Crafting.Bits.DEFAULT, new Object[] {"   ", "dP ", "   ", 'P', ST.make(this, 1, W)});
		
		UT.Crafting.shaped(ST.make(this, 1, 9), UT.Crafting.Bits.DEFAULT, new Object[] {"P d", "   ", "   ", 'P', ST.make(this, 1, W)});
		UT.Crafting.shaped(ST.make(this, 1,10), UT.Crafting.Bits.DEFAULT, new Object[] {"P  ", "  d", "   ", 'P', ST.make(this, 1, W)});
		UT.Crafting.shaped(ST.make(this, 1,11), UT.Crafting.Bits.DEFAULT, new Object[] {"P  ", "   ", "  d", 'P', ST.make(this, 1, W)});
		UT.Crafting.shaped(ST.make(this, 1,12), UT.Crafting.Bits.DEFAULT, new Object[] {"P  ", "   ", " d ", 'P', ST.make(this, 1, W)});
		UT.Crafting.shaped(ST.make(this, 1,13), UT.Crafting.Bits.DEFAULT, new Object[] {"  P", "   ", "  d", 'P', ST.make(this, 1, W)});
		UT.Crafting.shaped(ST.make(this, 1,14), UT.Crafting.Bits.DEFAULT, new Object[] {"  P", "   ", " d ", 'P', ST.make(this, 1, W)});
		UT.Crafting.shaped(ST.make(this, 1,15), UT.Crafting.Bits.DEFAULT, new Object[] {"  P", "   ", "d  ", 'P', ST.make(this, 1, W)});
		UT.Crafting.shaped(ST.make(this, 1,16), UT.Crafting.Bits.DEFAULT, new Object[] {"  P", "d  ", "   ", 'P', ST.make(this, 1, W)});
		UT.Crafting.shaped(ST.make(this, 1,17), UT.Crafting.Bits.DEFAULT, new Object[] {"   ", "   ", "d P", 'P', ST.make(this, 1, W)});
		UT.Crafting.shaped(ST.make(this, 1,18), UT.Crafting.Bits.DEFAULT, new Object[] {"   ", "d  ", "  P", 'P', ST.make(this, 1, W)});
		UT.Crafting.shaped(ST.make(this, 1,19), UT.Crafting.Bits.DEFAULT, new Object[] {"d  ", "   ", "  P", 'P', ST.make(this, 1, W)});
		UT.Crafting.shaped(ST.make(this, 1,20), UT.Crafting.Bits.DEFAULT, new Object[] {" d ", "   ", "  P", 'P', ST.make(this, 1, W)});
		UT.Crafting.shaped(ST.make(this, 1,21), UT.Crafting.Bits.DEFAULT, new Object[] {"d  ", "   ", "P  ", 'P', ST.make(this, 1, W)});
		UT.Crafting.shaped(ST.make(this, 1,22), UT.Crafting.Bits.DEFAULT, new Object[] {" d ", "   ", "P  ", 'P', ST.make(this, 1, W)});
		UT.Crafting.shaped(ST.make(this, 1,23), UT.Crafting.Bits.DEFAULT, new Object[] {"  d", "   ", "P  ", 'P', ST.make(this, 1, W)});
		UT.Crafting.shaped(ST.make(this, 1,24), UT.Crafting.Bits.DEFAULT, new Object[] {"   ", "  d", "P  ", 'P', ST.make(this, 1, W)});
	}
	
	protected IIcon[] mIcons = new IIcon[256];
	
	@Override
	public IIcon getIconFromDamage(int aMeta) {
		return mIcons[aMeta & 255];
	}
	
	@Override
	public void addAdditionalToolTips(List aList, ItemStack aStack, boolean aF3_H) {
		super.addAdditionalToolTips(aList, aStack, aF3_H);
		aList.add(LanguageHandler.get(getUnlocalizedName() + ".configuration", "Configuration: ") + getConfigurationString(getDamage(aStack)));
	}
	
	@Override
	public String getUnlocalizedName(ItemStack aStack) {
		return getUnlocalizedName();
	}
	
	@Override
	@SideOnly(Side.CLIENT)
	public final void getSubItems(Item var1, CreativeTabs aCreativeTab, List aList) {
		aList.add(ST.make(this, 1, 0));
	}
	
	@Override
	@SideOnly(Side.CLIENT)
	public void registerIcons(IIconRegister aIconRegister) {
		for (int i = 0; i < 25/*TODO mIcons.length*/; i++) mIcons[i] = aIconRegister.registerIcon(mModID + ":" + mName + "/" + (byte)(i&255));
		// Useful hack to register Item Icons. That is why the Integrated Circuit Item has to exist always.
		if (Abstract_Mod.sFinalized >= Abstract_Mod.sModCountUsingGTAPI) {
			OUT.println("GT_API: Setting up Icon Register for Items");
			GT_API.sItemIcons = aIconRegister;
			OUT.println("GT_API: Starting Item Icon Load Phase");
			for (Runnable tRunnable : GT_API.sItemIconload) {
				try {
					tRunnable.run();
				} catch(Throwable e) {
					e.printStackTrace(ERR);
				}
			}
			OUT.println("GT_API: Finished Item Icon Load Phase");
		}
	}
	
	private static String getModeString(int aMetaData) {
		switch ((byte)(aMetaData >>> 8)) {
		case  0: return "==";
		case  1: return "<=";
		case  2: return ">=";
		case  3: return "<";
		case  4: return ">";
		default: return "";
		}
	}
	
	private static String getConfigurationString(int aMetaData) {
		return getModeString(aMetaData) + " " + (byte)(aMetaData & 255);
	}
}