package gregapi.recipes.maps;

import static gregapi.data.CS.*;
import gregapi.data.MT;
import gregapi.item.IItemColorableRGB;
import gregapi.random.IHasWorldAndCoords;
import gregapi.recipes.Recipe;
import gregapi.recipes.Recipe.RecipeMap;
import gregapi.util.ST;
import gregapi.util.UT;

import java.util.Collection;

import net.minecraft.init.Items;
import net.minecraft.item.ItemArmor;
import net.minecraft.item.ItemStack;
import net.minecraftforge.fluids.FluidStack;

/**
 * @author Gregorius Techneticies
 */
public class RecipeMapBath extends RecipeMap {
	public RecipeMapBath(Collection<Recipe> aRecipeList, String aUnlocalizedName, String aNameLocal, String aNameNEI, long aProgressBarDirection, long aProgressBarAmount, String aNEIGUIPath, long aInputItemsCount, long aOutputItemsCount, long aMinimalInputItems, long aInputFluidCount, long aOutputFluidCount, long aMinimalInputFluids, long aMinimalInputs, long aPower, String aNEISpecialValuePre, long aNEISpecialValueMultiplier, String aNEISpecialValuePost, boolean aShowVoltageAmperageInNEI, boolean aNEIAllowed, boolean aConfigAllowed, boolean aNeedsOutputs) {
		super(aRecipeList, aUnlocalizedName, aNameLocal, aNameNEI, aProgressBarDirection, aProgressBarAmount, aNEIGUIPath, aInputItemsCount, aOutputItemsCount, aMinimalInputItems, aInputFluidCount, aOutputFluidCount, aMinimalInputFluids, aMinimalInputs, aPower, aNEISpecialValuePre, aNEISpecialValueMultiplier, aNEISpecialValuePost, aShowVoltageAmperageInNEI, aNEIAllowed, aConfigAllowed, aNeedsOutputs);
	}
	
	@Override
	public Recipe findRecipe(IHasWorldAndCoords aTileEntity, Recipe aRecipe, boolean aNotUnificated, long aSize, ItemStack aSpecialSlot, FluidStack[] aFluids, ItemStack... aInputs) {
		Recipe rRecipe = super.findRecipe(aTileEntity, aRecipe, aNotUnificated, aSize, aSpecialSlot, aFluids, aInputs);
		if (aInputs == null || aInputs.length < 1 || aInputs[0] == null || aFluids.length < 1 || aFluids[0] == null || GAPI_POST.mFinishedServerStarted <= 0) return rRecipe;
		if (rRecipe == null) for (ItemStack aInput : aInputs) if (aInput != null) {
			if (aInput.getItem() instanceof ItemArmor) for (byte tColor = 0; tColor < 16; tColor++) for (FluidStack aDye : DYE_FLUIDS[tColor]) if (UT.Fluids.equal(aDye, aFluids[0])) {
				ItemStack tOutput = UT.Crafting.getany(aTileEntity==null?DW:aTileEntity.getWorld(), new ItemStack[] {aInput, NI, NI, NI, NI, NI, NI, NI, ST.make(Items.dye, 1, tColor)});
				if (ST.invalid(tOutput)) return null;
				rRecipe = new Recipe(F, F, new ItemStack[] {ST.amount(1, aInput)}, new ItemStack[] {tOutput}, null, null, new FluidStack[] {aDye}, null, 512, 0, 0);
				rRecipe.mCanBeBuffered = F;
				return rRecipe;
			}
			if (aInput.getItem() instanceof IItemColorableRGB) {
				if (((IItemColorableRGB)aInput.getItem()).canDecolorItem(aInput)) if (UT.Fluids.equal(MT.Cl.fluid(U, T), aFluids[0])) {
					ItemStack tOutput = ST.amount(1, aInput);
					if (!((IItemColorableRGB)tOutput.getItem()).decolorItem(tOutput) || ST.invalid(tOutput)) return null;
					rRecipe = new Recipe(F, F, new ItemStack[] {ST.amount(1, aInput)}, new ItemStack[] {tOutput}, null, null, new FluidStack[] {MT.Cl.fluid(U/8, T)}, null, 512, 0, 0);
					rRecipe.mCanBeBuffered = F;
					return rRecipe;
				}
				if (((IItemColorableRGB)aInput.getItem()).canRecolorItem(aInput)) for (byte tColor = 0; tColor < 16; tColor++) for (FluidStack aDye : DYE_FLUIDS[tColor]) if (UT.Fluids.equal(aDye, aFluids[0])) {
					ItemStack tOutput = ST.amount(1, aInput);
					if (!((IItemColorableRGB)tOutput.getItem()).recolorItem(tOutput, DYES_INT[tColor]) || ST.invalid(tOutput)) return null;
					rRecipe = new Recipe(F, F, new ItemStack[] {ST.amount(1, aInput)}, new ItemStack[] {tOutput}, null, null, new FluidStack[] {UT.Fluids.mul(aDye, 1, 8, T)}, null, 512, 0, 0);
					rRecipe.mCanBeBuffered = F;
					return rRecipe;
				}
			}
		}
		return rRecipe;
	}
	
	@Override public boolean containsInput(ItemStack aStack, IHasWorldAndCoords aTileEntity, ItemStack aSpecialSlot) {return (aStack != null && (aStack.getItem() instanceof ItemArmor || (aStack.getItem() instanceof IItemColorableRGB && (((IItemColorableRGB)aStack.getItem()).canRecolorItem(aStack) || ((IItemColorableRGB)aStack.getItem()).canDecolorItem(aStack))))) || super.containsInput(aStack, aTileEntity, aSpecialSlot);}
}