package gregapi.tileentity.tools;

import static gregapi.data.CS.OPPOSITES;
import gregapi.code.TagData;
import gregapi.data.TD;
import gregapi.item.IItemEnergy;
import gregapi.old.Textures;
import gregapi.render.BlockTextureDefault;
import gregapi.render.BlockTextureMulti;
import gregapi.render.IIconContainer;
import gregapi.render.ITexture;
import gregapi.tileentity.energy.ITileEntityEnergyElectricityAcceptor;
import gregapi.tileentity.energy.ITileEntityEnergyFluxHandler;

import java.util.Collection;

import net.minecraft.block.Block;


/**
 * @author Gregorius Techneticies
 */
public class MultiTileEntityChargingCraftingTable extends MultiTileEntityAdvancedCraftingTable implements ITileEntityEnergyElectricityAcceptor, ITileEntityEnergyFluxHandler {
	@Override public String getTileEntityName() {return "gt.multitileentity.crafting.charging";}
	
	@Override
	public long doInject(TagData aEnergyType, byte aSide, long aSize, long aAmount, boolean aDoInject) {
		for (int i : SLOTS_TOOLS) if (slotHas(i) && slot(i).getItem() instanceof IItemEnergy) {
			long rReturn = ((IItemEnergy)slot(i).getItem()).doEnergyInjection(aEnergyType, slot(i), aSize, aAmount, this, getWorld(), getX(), getY(), getZ(), aDoInject);
			if (rReturn != 0) return rReturn;
		}
		return 0;
	}
	
	@Override public boolean isEnergyType					(TagData aEnergyType, byte aSide, boolean aEmitting) {return !aEmitting;}
	@Override public long getEnergySizeInputMin				(TagData aEnergyType, byte aSide) {return 1;}
	@Override public long getEnergySizeInputMax				(TagData aEnergyType, byte aSide) {return Long.MAX_VALUE;}
	@Override public long getEnergySizeInputRecommended		(TagData aEnergyType, byte aSide) {return Long.MAX_VALUE;}
	@Override public Collection<TagData> getEnergyTypes(byte aSide) {return TD.Energy.ALL;}
	
	@Override
	public ITexture getTexture2(Block aBlock, int aRenderPass, byte aSide, boolean[] aShouldSideBeRendered) {
		if (!aShouldSideBeRendered[aSide]) return null;
		int aIndex = aSide<2?aSide:aSide==mFacing?2:aSide==OPPOSITES[mFacing]?3:4;
		return BlockTextureMulti.get(BlockTextureDefault.get(sColoreds[aIndex], mRGBa), BlockTextureDefault.get(sOverlays[aIndex]));
	}
	
	@SuppressWarnings("hiding")
	public static IIconContainer sColoreds[] = new IIconContainer[] {
		new Textures.BlockIcons.CustomIcon("machines/craftingtables/charging/colored/bottom"),
		new Textures.BlockIcons.CustomIcon("machines/craftingtables/charging/colored/top"),
		new Textures.BlockIcons.CustomIcon("machines/craftingtables/charging/colored/front"),
		new Textures.BlockIcons.CustomIcon("machines/craftingtables/charging/colored/back"),
		new Textures.BlockIcons.CustomIcon("machines/craftingtables/charging/colored/side"),
	}, sOverlays[] = new IIconContainer[] {
		new Textures.BlockIcons.CustomIcon("machines/craftingtables/charging/overlay/bottom"),
		new Textures.BlockIcons.CustomIcon("machines/craftingtables/charging/overlay/top"),
		new Textures.BlockIcons.CustomIcon("machines/craftingtables/charging/overlay/front"),
		new Textures.BlockIcons.CustomIcon("machines/craftingtables/charging/overlay/back"),
		new Textures.BlockIcons.CustomIcon("machines/craftingtables/charging/overlay/side"),
	};
}